{$IFDEF VER70}
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S+,T-,V-,X-}
{$ELSE}
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S+,V-,X-}
{$ENDIF}
{$M 8192,0,0}

Const
  SP = Byte(' ');

Type
  TTriplet = Array[0..2] of Byte;
  TKwartet = Array[0..3] of Byte;

var Triplets: Array[1..15] of TTriplet;
    kwar: TKwartet;
    FileName: String[12];
    i,j: Integer;
    f: File;
    g: Text;
    Fs,CurSize : LongInt;


    FUNCTION UpperStr(S : STRING) : STRING;
    VAR sLen : BYTE ABSOLUTE S;
        I    : BYTE;
    BEGIN
    FOR I := 1 TO sLEN DO S[i] := UpCase(S[i]);
    UpperStr := S;
    END;

    procedure Triplet2Kwartet(Triplet: TTriplet; var Kwartet: TKwartet);
    var i: Integer;
    begin
      Kwartet[0] := (Triplet[0] SHR 2);
      Kwartet[1] := ((Triplet[0] SHL 4) AND $30) +
                    ((Triplet[1] SHR 4) AND $0F);
      Kwartet[2] := ((Triplet[1] SHL 2) AND $3C) +
                    ((Triplet[2] SHR 6) AND $03);
      Kwartet[3] := (Triplet[2] AND $3F);
      for i:=0 to 3 do
      begin
        if Kwartet[i] = 0 then Kwartet[i] := $40;
        Inc(Kwartet[i],SP)
      end
    end {Triplet2Kwartet};


begin
  writeln('UUEnCode 1.01 (c) 1994 by Vitaliy V. Siman');
  writeln('Special thanks : DwarFools & Consultancy by drs. Robert E. Swart');
  writeln;
  if ParamCount = 0 then
  begin
    writeln('Usage: UUEnCode infile [outfile]');
    Halt
  end;
  if UpperStr(ParamStr(1)) = UpperStr(ParamStr(2)) then
  begin
    writeln('Error: infile = outfile');
    Halt(1)
  end;

  Assign(f,ParamStr(1));
  FileMode := $40;
  reset(f,1);
  if IOResult <> 0 then
  begin
    writeln('Error: could not open file ',ParamStr(1));
    Halt(2)
  end;

  if ParamCount < 2 then
  begin
    FileName := ParamStr(1);
    i := Pos('.',FileName);
    if i > 0 then Delete(FileName,i,Length(FileName));
    FileName := FileName + '.UUE'
  end
  else FileName := ParamStr(2);

  if UpperStr(ParamStr(1)) = UpperStr(FileName) then
  begin
    writeln('Error: input file = output file');
    Halt(1)
  end;

  Assign(g,FileName);
  if ParamCount > 1 then
  begin
    FileMode := $02;
    reset(g);
    if IOResult = 0 then
    begin
      writeln('Error: file ',FileName,' already exists.');
      halt(3)
    end
  end;
  Fs := FileSize(f);
  rewrite(g);
  if IOResult <> 0 then
  begin
    writeln('Error: could not create file ',FileName);
    Halt(4)
  end;
  FillChar(Triplets,SizeOf(Triplets),#0);
  writeln(g,'begin 660 ',UpperStr(ParamStr(1)));
  repeat
    BlockRead(f,Triplets,SizeOf(Triplets),i);
    CurSize := CurSize + i;
    Write('Done ',(Round(CurSize/Fs*100)):3,'%',#13);
    write(g,Char(SP+i));
    for j:=1 to (i+2) div 3 do
    begin
      Triplet2Kwartet(Triplets[j],kwar);
      write(g,Char(kwar[0]),Char(kwar[1]),Char(kwar[2]),Char(kwar[3]))
    end;
    writeln(g);
  until (i < SizeOf(Triplets));
  writeln(g,'`');
  writeln(g,'end');
  close(f);
  close(g);
  Write('Done 100%',#13);
  if ParamCount <> 0 then
    writeln('UUEncoded file ',UpperStr(FileName),' created.');
  writeln
end.

